<%@ LANGUAGE="VBSCRIPT" %>
<% PageStrings = "359, 401, 402, 545, 549, 550, 553, 556, 557, 580, 581, 582, 583, 584, 832, 1235, 1282, 1489, 1843, 1869, 1926"
strThisBackPage = "products" %>
<!--#include file="includes/config.asp"-->
<!--#include file="includes/functions.asp"-->
<!--#include file="includes/back_security.asp"-->
<!--#include file="includes/back_productpage.asp"-->
<%
'===============================================
' CactuShop ASP Shopping Cart
' 1999-2006 Cactusoft International FZ-LLC
' www.cactusoft.com
'===============================================
' All rights reserved.							
' Use of this code is covered by the terms and	
' conditions in the license agreement. No		
' unauthorized duplication or distribution is	
' permitted. Cactusoft's copyright notices must	
' remain in the ASP sections of the code.		
'===============================================

'-----------------------------------------------
'CREATE COMBINATIONS
'Based on the defaults set to _combinations_set,
'this creates a for for each como.
'-----------------------------------------------

'Classes to hold option information
Class ProdOptionGroup
    Public GroupID
    Public GroupName(5)
    Public GroupOrder
    Public OptionCount
    Public OptionCurrent
    Public Options()

	Public Sub SetOptionArray()
		Redim Options(OptionCount)
	End Sub
	
End Class

Class ProdOption
	Public OptionID
	Public OptionName(5)
	Public OptionPriceChange
	Public OptionWeightChange
	Public OptionOrder
End Class


'Total number of combinations we're going to allow to be created
Const MAX_COMBINATIONS = 250

'Collect form values - these are set defaults
P_ID = request.Form("P_ID")
CAT_ID = request.Form("CAT_ID")
baseV_CodeNumber = request.Form("V_CodeNumber")
baseV_Price = request.Form("V_Price")
baseV_RRP = request.Form("V_RRP")
baseV_Weight = request.Form("V_Weight")
baseV_Tax = request.Form("V_Tax")
baseV_Quantity = request.Form("V_Quantity")
strStockTracking = request.Form("strStockTracking")
baseV_QuantityWarnLevel = request.Form("V_QuantityWarnLevel")

If baseV_Weight = "" then baseV_Weight = 0
blnCreateCombinations = (request.Form("strCreateCombinations") = "y")
If blnCreateCombinations then strCreateCombinations = "y" else strCreateCombinations = "n"

'-----------------------------------------------
'DECIDE WHETHER WE'RE EDITING, AND IF EDITING
'INDIVIDUAL COMBINATIONS
'-----------------------------------------------	
'Have we got a base type? - if so, we're editing
strQuery = "SELECT V_ID FROM tblCactuShop" & TABLE_PREFIX & "Versions WHERE V_ProductID = " & P_ID & " AND V_Type IN ('o', 'b')"
Call ExecuteRS(strQuery, objRecordSeT)
If not (objRecordSet.BOF And objRecordSet.EOF) then
	blnEditing = true
	baseV_ID = objRecordSet("V_ID")
end if
objRecordSet.Close
	
'If we're editing, check to see if we've got a combination version
'If so, then we're editing individual values
If blnEditing then
	'Keep the recordset open - we'll use that later if we've got records
	strQuery = "SELECT * FROM tblCactuShop" & TABLE_PREFIX & "Versions WHERE V_ProductID = " & P_ID & " AND V_Type = 'c' ORDER BY V_OrderByValue"
	Call ExecuteRS(strQuery, objRecordSet)
	blnIndividual = not (objRecordSet.BOF And objRecordSet.EOF)
End If


'Error-check the values - so shouldn't be changed if
'we're editing individual values
If not blnIndividual then
	strErrorMsg = BackendCheckBlank(strErrorMsg, numErrorNo, GetString("FormLabel_CodeNumer"), baseV_CodeNumber)
	strErrorMsg = BackendCheckLength(strErrorMsg, numErrorNo, GetString("FormLabel_CodeNumer"), baseV_CodeNumber, GetAppVar("V_CodeNumber_AL"))

	IF baseV_Quantity = "" then baseV_Quantity = 0
	If Not IsNumeric(baseV_Quantity) Then
		numErrorNo = numErrorNo + 1
		strErrorMsg = strErrorMsg + "<b>" + CStr(numErrorNo) + ".</b> " + GetString("ContentText_ErrorChkQuantityIsNumeric") & "<br />"
	End if

	IF baseV_QuantityWarnLevel = "" then baseV_QuantityWarnLevel = 0
	If Not IsNumeric(baseV_QuantityWarnLevel) Then
		numErrorNo = numErrorNo + 1
		strErrorMsg = strErrorMsg + "<b>" + CStr(numErrorNo) + ".</b> " + GetString("ContentText_ErrorChkQuantityWarnLevelIsNumeric") & "<br />"
	End if
	
	'If stock tracking turned on but they didn't set a warn level, error	
	If strStockTracking = "y" and baseV_QuantityWarnLevel = 0 Then
		numErrorNo = numErrorNo + 1
		strErrorMsg = strErrorMsg + "<b>" + CStr(numErrorNo) + ".</b> " + GetString("ContentText_ErrorStockTrackingWarnLevel") & "<br />"
	End if

End If

If Not IsNumeric(baseV_Price) or baseV_Price = "" Then
	numErrorNo = numErrorNo + 1
	strErrorMsg = strErrorMsg + "<b>" + CStr(numErrorNo) + ".</b> " + GetString("ContentText_ErrorChkPriceIsNumeric") & "<br />"
End if

If Not IsNumeric(baseV_Weight) Then
	numErrorNo = numErrorNo + 1
	strErrorMsg = strErrorMsg + "<b>" + CStr(numErrorNo) + ".</b> " + GetString("ContentText_ErrorChkWeightIsNumeric") & "<br />"
End if

IF baseV_RRP = "" then baseV_RRP = 0
If Not IsNumeric(baseV_RRP) Then
	numErrorNo = numErrorNo + 1
	strErrorMsg = strErrorMsg + "<b>" + CStr(numErrorNo) + ".</b> " + GetString("ContentText_ErrorChkRRPIsNumeric") & "<br />"
End if

If strErrorMsg = "" then 

	'All this options stuff can be skipped out if editing individual
	'combinations, as this data comes from the db
	If not blnIndividual then

		'Get all the option groups
		strOptionGroupIDs = request.Form("strOptionGroups")
		aryOptionGroupIDs = split(strOptionGroupIDs, ", ")
		
		'Redim the strOptionGroups array to hold all groups
		ReDim aryOptionGroups(ubound(aryOptionGroupIDs) + 1)	
		numCombinations = 1
		
		'Loop through all groups
		For Each strOptionGroupID In aryOptionGroupIDs
			'Get out group info
			numOptionCount = 0
			OPTG_ID = strOptionGroupID

			'Pull out the options for this group
			strOptions = request.Form(OPTG_ID & "strOptions")
			aryOptions = Split(strOptions, ", ")
			If strOptions <> "" then 
				numOptionGroupCount = numOptionGroupCount + 1
				Set aryOptionGroups(numOptionGroupCount) = New ProdOptionGroup
								
				'Save group to array
				aryOptionGroups(numOptionGroupCount).GroupID = OPTG_ID
				
				'Do names
				For numCount = 1 to numTotalLanguages
					aryOptionGroups(numOptionGroupCount).GroupName(numCount) = request.form(OPTG_ID & "strOptionGroupName" & numCount)
				Next			
				
				'Set option group ordering value
				numOrderValue = request.Form(OPTG_ID & "numGroupOrder")
				If not isnumeric(numOrderValue) or numOrderValue = "" then numOrderValue = 0 else numOrderValue = NumSafe(numOrderValue)
				aryOptionGroups(numOptionGroupCount).GroupOrder = numOrderValue
				
				'Get which option is selected
				numSelected = request.Form(OPTG_ID & "numSelected")
				
				'Set counts, define option array in the group
				aryOptionGroups(numOptionGroupCount).OptionCount = ubound(aryOptions) + 1
				aryOptionGroups(numOptionGroupCount).OptionCurrent = 1
				numCombinations = numCombinations * aryOptionGroups(numOptionGroupCount).OptionCount
				
				'Don't bother proceding if we've hit the max
				If numCombinations >= MAX_COMBINATIONS and blnCreateCombinations then 
					strErrorMsg = GetString("ContentText_TooManyCombos") & " (" & MAX_COMBINATIONS & ")."
					Exit For
				End If
									
				aryOptionGroups(numOptionGroupCount).SetOptionArray
				
				'Pass on all the information for option groups and options in hidden fields
				strHiddenFields = strHiddenFields & "<input type=""hidden"" name=""strOptionGroups"" value=""" & OPTG_ID & """ />" & vbcrlf
				strHiddenFields = strHiddenFields & "<input type=""hidden"" name=""" & OPTG_ID & "numGroupOrder"" value=""" & aryOptionGroups(numOptionGroupCount).GroupOrder & """ />" & vbcrlf
				strHiddenFields = strHiddenFields & "<input type=""hidden"" name=""" & OPTG_ID & "strOptions"" value=""" & strOptions & """ />" & vbcrlf
				strHiddenFields = strHiddenFields & "<input type=""hidden"" name=""" & OPTG_ID & "numSelected"" value=""" & numSelected & """ />" & vbcrlf
												
				For Each numOption in aryOptions
					'Save to array
					numOptionCount = numOptionCount + 1
					Set aryOptionGroups(numOptionGroupCount).Options(numOptionCount) = New ProdOption
					aryOptionGroups(numOptionGroupCount).Options(numOptionCount).OptionID = numOption
					aryOptionGroups(numOptionGroupCount).Options(numOptionCount).OptionPriceChange = NumSafe(request.Form(numOption & "numPriceChange"))
					aryOptionGroups(numOptionGroupCount).Options(numOptionCount).OptionWeightChange = NumSafe(request.Form(numOption & "numWeightChange"))
					aryOptionGroups(numOptionGroupCount).Options(numOptionCount).OptionOrder = NumSafe(request.Form(numOption & "numOptionOrder"))
					
					'If it's a 'no' checked value, then don't do names
					If Not (request.Form(numOption & "strNoCheckBox") = "y") then
						For numCount = 1 to numTotalLanguages
							aryOptionGroups(numOptionGroupCount).Options(numOptionCount).OptionName(numCount) = Request.Form(numOption & "strOptionName" & numCount)
						Next
					End If
					
					'Pass on option information in hidden fields
					strHiddenFields = strHiddenFields & "<input type=""hidden"" name=""" & numOption & "numPriceChange"" value=""" & aryOptionGroups(numOptionGroupCount).Options(numOptionCount).OptionPriceChange & """ />" & vbcrlf
					strHiddenFields = strHiddenFields & "<input type=""hidden"" name=""" & numOption & "numWeightChange"" value=""" & aryOptionGroups(numOptionGroupCount).Options(numOptionCount).OptionWeightChange & """ />" & vbcrlf
					strHiddenFields = strHiddenFields & "<input type=""hidden"" name=""" & numOption & "numOptionOrder"" value=""" & aryOptionGroups(numOptionGroupCount).Options(numOptionCount).OptionOrder & """ />" & vbcrlf
					
				Next
			End If '// option selections made?

		Next '// Next option group
		
		If numOptionGroupCount = 0 then
			strErrorMsg = GetString("ContentText_NoOptionsSelected")
		End If
			
	else
		'Set the total 'combinations' to the records we've got in the db
		numCombinations = objRecordSet.RecordCount
		
		'To work out the price and weight - instead of running through code
		'like the above to calculate new prices and weights for each combination,
		'what we do is work out the different between the old base price & weight
		'(passed through hidden form) and the new one. Then the DB value on each
		'version just has to add on the difference.
		origV_Price = request.Form("origV_Price")
		origV_Weight = request.Form("origV_Weight")
		
		numPriceDifference = baseV_Price - origV_Price
		numWeightDifference = baseV_Weight - origV_Weight
		
	end if '// not editing individual combinations?
	
end if

If blnCreateCombinations Or strErrorMsg <> "" then 
	%>
	<html>
	<head>
		<link rel="Bookmark" href="favicon.ico" />
		<link rel="SHORTCUT ICON" href="favicon.ico" />
		<link href="includes/backend.css" rel="stylesheet" title="cactusoft" type="text/css" />
		<link href="includes/adminbar.css" rel="stylesheet" title="cactusoft" type="text/css" />
		<meta name="GENERATOR" content="www.cactusoft.com" />
		<!---
		===============================================================================
		CACTUSHOP v6 ASP SHOPPING CART
		1999-2006 CACTUSOFT INTERNATIONAL FZ-LLC. - WWW.CACTUSHOP.COM
		All rights reserved.
		===============================================================================
		---->
		<title><% =GetString("Config_headtitle") %></title>
	</head>
	<body bgcolor="#FFFFFF" LEFTMARGIN="0" TOPMARGIN="0" MARGINWIDTH="0" MARGINHEIGHT="0">

	<table border="0" cellpadding="0" cellspacing="0" width="100%">
	<tr>
		<td colspan="2"><!--#include file="includes/back_header.asp"--></td>
	</tr>
	</table>
	<table border="0" cellpadding="0" cellspacing="0" width="660">
	<tr>
		<td valign="top" width="190"><!--#include file="includes/back_menu.asp"--></td>
<% end if %>
	
<% if strErrorMsg <> "" then 
	'Show errors %>
	<td valign="top">
		<%= strProductHTML %>
		<table border="0" cellpadding="5" cellspacing="0" width="100%">
			<tr>
				<td><h1><% WriteString("PageTitle_Problems") %></h1></td>
			</tr>
			<tr>
				<td><% WriteString("ContentText_PleaseGoBackAndCorrect") %></td>
			</tr>
			<tr>
				<td><% =strErrorMsg %></td>
			</tr>	
			<tr>
				<td class="small"><br /><br /><a href="javascript:history.back()">&lt;&lt; <% WriteString("ContentText_BackLink") %></a></td>
			</tr>	 
		</table>
	</td>
	
<% else 

	'Show Form %>

		<% If blnCreateCombinations then %>
			<td valign="top">
		<% else %>
			<html><body>
		<% end if %>
		
		<form action="_combinations_process.asp" name="combo" method="post">
			<%= objCactuSession.Form %>
			<%= strProductForm %>
			<input type="hidden" name="V_ProductID" value="<%= P_ID %>" />
			<input type="hidden" name="V_Live" value="y" />
			<input type="hidden" name="V_Tax" value="<%= baseV_Tax %>" />
			<input type="hidden" name="V_Desc" value="" />
			<input type="hidden" name="V_RRP" value="<%= baseV_RRP %>" />
			<input type="hidden" name="numCombinations" value="<%= numCombinations %>" />
			<input type="hidden" name="strCreateCombinations" value="<%= strCreateCombinations %>" />
			<input type="hidden" name="V_CodeNumber" value="<%= baseV_CodeNumber %>" />
			<input type="hidden" name="V_Price" value="<%= baseV_Price %>" />
			<input type="hidden" name="V_Weight" value="<%= baseV_Weight %>" />
			<input type="hidden" name="V_Quantity" value="<%= baseV_Quantity %>" />
			<input type="hidden" name="V_QuantityWarnLevel" value="<%= baseV_QuantityWarnLevel %>" />
			<input type="hidden" name="baseV_ID" value="<%= baseV_ID %>" />
			
			<%= strHiddenFields %>
		    
			<%
			'--------------------------------------------
			'SHOW COMBINATION FORMS?
			'--------------------------------------------
			If blnCreateCombinations then %>
		    
				<table border="0" cellpadding="5" cellspacing="0" width="100%">
				<tr>
					<td><h1><% WriteString("PageTitle_Combinations") %></h1></td>
				</tr>
				<tr>
					<td><table cellpadding="2" cellspacing="0" width="100%">
							<%
						'Now run each option group and create the combinations
						For i = 1 To numCombinations
							'Set some defaults
							Redim V_Name(5)
							V_Price = baseV_Price
							V_Weight = baseV_Weight
							V_CodeNumber = baseV_CodeNumber
							
							'If we're editing combinations, it's a simple case of setting
							'the values to those in the database
							If blnIndividual then
								V_ID = objRecordSet("V_ID")
								V_CodeNumber = objRecordSet("V_CodeNumber")
								baseV_Quantity = objRecordSet("V_Quantity")
								baseV_QuantityWarnLevel = objRecordSet("V_QuantityWarnLevel")
																
								For numCount = 1 to numTotalLanguages
									V_Name(numCount) = objRecordSet("V_Name" & numCount)
								Next
								
								'Price and weight set based on the DB value plus the
								'difference between old and new	values. See above for details
								V_Price = objRecordSet("V_Price") + numPriceDifference
								V_Weight = objRecordSet("V_Weight") + numWeightDifference
								
								objRecordSet.MoveNext
							
							else
								'we're adding new versions - set ID to 0
								V_ID = 0
								
								'Loop through each feature we've got to build up the name,
								'price modifier and weight modifier
								For j = 1 To numOptionGroupCount	
									numOptCurrent = aryOptionGroups(j).OptionCurrent
									
									'Do name
									For numCount = 1 to numTotalLanguages
										If not aryOptionGroups(j).Options(numOptCurrent).OptionName(numCount) = "" then
											If V_Name(numCount) = "" then
												V_Name(numCount) = aryOptionGroups(j).Options(numOptCurrent).OptionName(numCount)
											Else
												V_Name(numCount) = V_Name(numCount) & ", " & aryOptionGroups(j).Options(numOptCurrent).OptionName(numCount)
											End If
										End If
									Next
									
									'Do hidden 'options' value
									response.Write "<input type=""hidden"" name=""" & i & "V_Options"" value=""" & aryOptionGroups(j).Options(numOptCurrent).OptionID & """ />"
									
									V_Price = V_Price + aryOptionGroups(j).Options(numOptCurrent).OptionPriceChange
									V_Weight = V_Weight + aryOptionGroups(j).Options(numOptCurrent).OptionWeightChange
								Next

								'Have to just make up the code number by tagging on the
								'count on to the base				
								V_CodeNumber = V_CodeNumber & "-" & i
								
							end if '// doing individual records 
								
							%>
							
							
							<tr bgcolor="#eeeeee">
								<td colspan="6" width="100%" class="small bold">
									<input type="hidden" name="<%= i %>V_ID" value="<%= V_ID %>" />
									<input type="hidden" name="<%= i %>V_Price" value="<%= V_Price %>" />
									<input type="hidden" name="<%= i %>V_Weight" value="<%= V_Weight %>" />
									<%= i %>.
									<% WriteString("ContentText_Price") %>&nbsp;<%= objDefaultCurrency.Display(V_Price, false, false) %>, 
									<% WriteString("FormLabel_Weight") %>&nbsp;<%= V_Weight & GetAppVar("weightunit") %>
								</td>
							</tr>
							
							<% 
							if numTotalLanguages > 1 then %>
								<tr>
									<td colspan="6" class="small bold"><% WriteString("FormLabel_VersionName") %>:</td>
								</tr>
								<% For numCount = 1 to numTotalLanguages
									If aryLangLiveBack(numCount) = "y" then  
									%>
										<tr>
											<td class="small"><%= aryLangBackNames(numCount) %></td>
											<td colspan="5"><input type="text" name="<%= i %>V_Name<%= numCount %>" value="<%= V_Name(numCount) %>" size="57" /></td>
										</tr>
									<% 
									end if 
									
								Next 
							Else %>
								<tr>
									<td class="small"><% WriteString("FormLabel_VersionName") %></td>
									<td colspan="5"><input type="text" name="<%= i %>V_Name<%= GetAppVar("defaultlanguage") %>" value="<%= V_Name(GetAppVar("defaultlanguage")) %>" size="57" /></td>
								</tr>					
							<% end if %>
							
							<tr>
								<td width="20%" class="small"><% WriteString("FormLabel_CodeNumer") %></td>
								<td width="16%"><input type="text" name="<%= i %>V_CodeNumber" value="<%= V_CodeNumber %>" size="10" /></td>
								<td width="20%" class="small"><% WriteString("FormLabel_StockQuantity") %></td>
								<td width="12%"><input type="text" name="<%= i %>V_Quantity" value="<%= baseV_Quantity %>" size="5" /></td>	
								<td width="20%" class="small"><% WriteString("FormLabel_WarningLevel") %></td>
								<td width="12%"><input type="text" name="<%= i %>V_QuantityWarnLevel" value="<%= baseV_QuantityWarnLevel %>" size="5" /></td>
							</tr>				
								
							<tr>
								<td colspan="6">&nbsp;</td>
							</tr>				
							
							<%
							'Decides what the next version combination should be:
							'Increment the first one. If it's hit the maximum, then
							'reset and increment the next one. Keep repeating until
							'one isn't maxed
							For j = 1 To numOptionGroupCount
								aryOptionGroups(j).OptionCurrent = aryOptionGroups(j).OptionCurrent + 1
								If aryOptionGroups(j).OptionCurrent > aryOptionGroups(j).OptionCount Then
									aryOptionGroups(j).OptionCurrent = 1
								Else
									Exit For
								End If
							Next
											
						Next
						%>
					</table></td>
				</tr>
				<tr>
					<td align="right"><input type="submit" name="btnUpdate" id="submit" value="<% WriteString("FormButton_CreateCombos") %>" /></td>
				</tr>
				</table>
			<% end if '// create combinations %>	
		</form>
		
	<% If blnCreateCombinations then %>
		</td>
	<% else %>
		<SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">
		<!--
			document.combo.submit();
		//-->
		</SCRIPT>	
		</body></html>
	<% end if %>
	
<% end if %>


<% If blnCreateCombinations then %>
	</tr>
</table>
</body>
</html>
<%
end if

Call EndPage()
%>
