<%@ LANGUAGE="VBSCRIPT" %>
<% PageStrings = "7, 8, 9, 31, 128, 129, 220, 233, 885, 886, 1148, 1188, 1189, 1190, 1191, 1192, 1193, 1194, 1195, 1744, 1745, 1751" %>
<!--#include file="includes/config.asp"-->
<!--#include file="includes/functions.asp"-->
<!--#include file="includes/functions_md5.asp"-->
<!--#include file="payment/payment.asp"-->
<%
'===============================================
' CactuShop ASP Shopping Cart
' 1999-2006 Cactusoft International FZ-LLC
' www.cactusoft.com
'===============================================
' All rights reserved.
' Use of this code is covered by the terms and
' conditions in the license agreement. No
' unauthorized duplication or distribution is
' permitted. Cactusoft's copyright notices must	
' remain in the ASP sections of the code.
'===============================================


'Create the gateway and process transaction
strCallbackError = ""
strPaymentSystem = DualRequest("g")
Set objPayment = New PaymentProcessor
If Not objPayment.SetGateway(strPaymentSystem) Then
	strCallbackError = "Incorrect payment gateway type provided ('" & strPaymentSystem & "')."
	blnWrongPaymentSystem = true
Else
	Call objPayment.Gateway.ProcessTransaction()
	strCallbackError = objPayment.Gateway.TransactionError
	With objPayment.Gateway.Callback
		
		'Try and grab order from the database
		If strCallbackError = "" then
			strQuery = "SELECT O_Sent, O_Details, O_CouponCode, O_TotalPriceGateway, O_WishListID, O_Status, C_EmailAddress FROM tblCactuShop" & TABLE_PREFIX & "Customers INNER JOIN tblCactuShop" & TABLE_PREFIX & "Orders ON tblCactuShop" & TABLE_PREFIX & "Customers.C_ID = tblCactuShop" & TABLE_PREFIX & "Orders.O_CustomerID WHERE O_ID=" & .OrderID & ""
			Call ExecuteRS(strQuery, objRecordSet)
			If not (objRecordSet.BOF and objRecordSet.EOF) then	
				O_Sent = objRecordSet("O_Sent")
				If O_Sent = "n" then
					'Store order details
					O_CouponCode = objRecordSet("O_CouponCode")
					O_TotalPriceGateway = NumSafe(objRecordSet("O_TotalPriceGateway"))
					WL_ID = NumSafe(objRecordSet("O_WishListID"))
					strBasket = objRecordSet("O_Status") & ""
					strBodyText = objRecordSet("O_Details") & ""
					
					'If not email was provided from the transaction, then get it from the DB
					If .CustomerEmail = "" then .CustomerEmail = objRecordSet("C_EmailAddress")
				Else
					strCallbackError = "Order already submitted (ID: " & .OrderID & ", Order sent: '" & O_Sent & "')"	
				End If
			Else
				strCallbackError = "Order id not found (" & .OrderID & ")"
			End If
			objRecordSet.Close
		End If

		'For security, check price matches
		If strCallbackError = "" then
			'If the order amount is set to 'skip' then skip this check.
			If Not .OrderAmount = "skip" then 
				If O_TotalPriceGateway <> .OrderAmount then
					strCallbackError = "Incorrect price match (value from database: " & O_TotalPriceGateway & "; value from gateway: " & .OrderAmount & ")"
				End If
			End If
		End If
		
		
		'Complete the order and create basket
		If strCallbackError = "" then
		
			'Create order basket
			aryBasket = Split(strBasket, "-")
			If strBasket = "" then
				strCallbackError = "Basket contents for order is blank."
				
			ElseIf UBound(aryBasket) <> 3 then
				strCallbackError = "Basket details invalid (" & strBasket & ")"
				
			Else
				Set objBasket = New Basket	
				strItems = aryBasket(0)
				strQuantities = aryBasket(1)
				strOptionGroups = aryBasket(2)
				strOptions = aryBasket(3)
				objBasket.Load strItems, strQuantities, strOptionGroups, strOptions
				objBasket.Validate objRecordSet, true
				If objBasket.Count = 0 then
					strCallbackError = "Basket is empty (" & strBasket & ")"
				End If
			End If
		End If
		
		'Process basket
		If strCallbackError = "" then
			'Update stock and log sale
			For i = 0 to objBasket.Count - 1
				With objBasket.Item(i)
					strQuery = "UPDATE tblCactuShop" & TABLE_PREFIX & "Versions SET V_Quantity = V_Quantity - " & .Quantity & " WHERE V_QuantityWarnLevel <> 0 AND V_ID=" & .VersionID
					Call ExecuteNonQuery(strQuery)
					LogSale .VersionID, .Quantity
				End With
			Next
		End If
		
		'Process wishlist
		If WL_ID > 0 then
			strQuery = "SELECT * FROM tblCactuShop" & TABLE_PREFIX & "WishList INNER JOIN tblCactuShop" & TABLE_PREFIX & "Customers ON tblCactuShop" & TABLE_PREFIX & "WishList.WL_CustomerID = tblCactuShop1Customers.C_ID WHERE WL_ID=" & WL_ID
			Call ExecuteRS(strQuery, objRecordSet)
			If Not (objRecordSet.BOF and objRecordSet.EOF) then
				'Load up the wishlist object
				Set objWishlist = New Basket
				objWishlist.Load objRecordSet("WL_Items"), objRecordSet("WL_Quantity"), objRecordSet("WL_OptionGroups"), objRecordSet("WL_Options")
				
				'Process wishlist and reduce if required
				blnMadeWishlistChange = false
				With objWishlist
					For i = 0 to objWishlist.Count - 1
						With .Item(i)
							'If it exist in the basket, decrease wishlist by quantity in the basket
							If objBasket.Exists(.m_versionID, .OptionsList) then
								.DecreaseQuantity(objBasket.Version(.VersionID, .OptionsList).Quantity)
								blnMadeWishlistChange = true
							End If
						End With
					Next
				
					'Reset the wishlist if changes have been made
					If blnMadeWishlistChange then
						.Clean
						strQuery = "UPDATE tblCactuShop" & TABLE_PREFIX & "WishList SET " &_
								"WL_Items='" & SQLSafe(.Items) & "', " &_
								"WL_Quantity='" & SQLSafe(.Quantities) & "', " &_
								"WL_OptionGroups='" & SQLSafe(.OptionGroups) & "', " &_
								"WL_Options='" & SQLSafe(.Options) & "' " &_
								"WHERE WL_ID=" & SQLSafe(WL_ID)
						Call ExecuteNonQuery(strQuery)
					End If
				End With				
				
			End If
			objRecordSet.Close
		End If
		
		'Reduce coupon
		If O_CouponCode <> "" then
			strQuery = "UPDATE tblCactuShop" & TABLE_PREFIX & "Coupons SET CP_Used='y' WHERE CP_CouponCode='" & SQLSafe(O_CouponCode) & "'"
			Call ExecuteRS(strQuery, objRecordSet)
		End if

		'Update order
		If strCallbackError = "" then
			O_Status = GetString("EmailText_OrderTime") & " " & NowOffset()
			strQuery = "UPDATE tblCactuShop" & TABLE_PREFIX & "Orders SET " &_
				"O_ReferenceCode='" & SQLSafe(objPayment.Gateway.TransactionID) & "', " &_
				"O_LastModified=" & strDateDelimiter & ReverseDate(NowOffset()) & strDateDelimiter & ", " &_
				"O_Sent='y', " &_
				"O_Invoiced='" & SQLSafe(GetAppVar("checkinvoicedonpayment")) & "', " &_
				"O_Paid='" & SQLSafe(GetAppVar("checkreceivedonpayment")) & "', " &_
				"O_Status='" & SQLSafe(O_Status) & "' " &_
				"WHERE O_ID=" & .OrderID
			Call ExecuteNonQuery(strQuery)
		end if


		'Send emails to customer and merchant
		If strCallbackError = "" then
		
			'EMAIL TO CUSTOMER
			If GetAppVar("ordertracking") = "y" then
				'Add order tracking information at the top
				strCustomerEmailText = GetString("EmailText_OrderLookup") & vbcrlf & vbcrlf & GetAppVar("webshopurl") & "customer_account.asp" & vbcrlf & vbcrlf & strBodyText
			End if	
			
			'Add in email header above that
			strCustomerEmailText = GetString("EmailText_OrderReceived") & vbcrlf & vbcrlf &_
								GetString("ContentText_OrderNumber") & ": " & .OrderID & vbcrlf & vbcrlf &_
								strCustomerEmailText

			'EMAIL TO STORE OWNER
			strStoreEmailText = GetString("EmailText_StoreEmailHeader") & vbcrlf & vbcrlf & strBodyText
			if GetAppVar("saveInEmail") = "y" then
				'Remove the special CC tags
				strStoreEmailText = Replace(strStoreEmailText, CARD_PLACEHOLDER, strCardInfo)
			else
				strStoreEmailText = Replace(strStoreEmailText, CARD_PLACEHOLDER, "")
			end if

			strCustomerEmailText = Replace(strCustomerEmailText, CARD_PLACEHOLDER, "")
			
			'Send email to customer
			If GetAppVar("emailcustomer") = "y" then
				Call SendEMail(GetAppVar("emailmethod"), GetAppVar("mailserver"), .CustomerEmail, "", "", strEmailFrom, strEmailFrom, strEmailFrom, strEmailFrom, GetString("Config_Subjectline"), strCustomerEmailText, "", false)
			End If
			
			'Send email to store owner
			If GetAppVar("emailmerchant") = "y" then
				Call SendEMail(GetAppVar("emailmethod"), GetAppVar("mailserver"), strEmailTo, "", "", strEmailFrom, strEmailFrom, strEmailFrom, strEmailFrom, GetString("Config_Subjectline2"), strStoreEmailText, "", false)
			End If
		End If
	End With	
End If

If strCallbackError = "" then
	'Show message to customer
	If objPayment.Gateway.ShowCallbackResponse then %>
		<div style="font-family: verdana; font-size: 12px">
			<p><strong><% WriteString("ContentText_TransactionSuccess") %></strong></p>
			<p><a href="<%= AddValueToURL(GetAppVar("webshopurl"), objCactuSession.QS) %>"><% WriteString("ContentText_ReturnToHomepage") %></a></p>
		</div><%
	end If
	
Else
	'Show declined message to customer
	If Not blnWrongPaymentSystem then
		If objPayment.Gateway.ShowCallbackResponse then %>
			<div style="font-family: verdana; font-size: 12px">
				<p><% WriteString("ContentText_TransactionFailure") %></p>
			</div>
		<% end if
	end if 
	
	'Send failure message to store owner
	If GetAppVar("senderroremail") = "y" then
	
		'Build up email text
		strBodyText =	GetString("Error_PaymentText") & vbcrlf & vbcrlf &_
						GetString("Error_PaymentDesc") & strCallbackError & vbcrlf &_
						GetString("Error_PaymentCactuShopVer") & CStr(CACTUSHOPVERSION) & vbcrlf &_
						GetString("Error_PaymentGateway") & strPaymentSystem & vbcrlf & vbcrlf
		
		'Server variables
		strBodyText = strBodyText & GetString("Error_PaymentServerVariables") & vbcrlf
		for each strItem in request.ServerVariables
			strBodyText = strBodyText & " - " & strItem & " : " & request.ServerVariables(strItem) & vbcrlf
		next
		
		'Form fields
		strBodyText = strBodyText & vbcrlf & GetString("Error_PaymentFormFields") & vbcrlf
		for each strItem in request.Form
			strBodyText = strBodyText & " - " & strItem & " : " & request.Form(strItem) & vbcrlf
		next

		'querystring fields
		strBodyText = strBodyText & vbcrlf & GetString("Error_PaymentQuerystring") & vbcrlf
		for each strItem in request.querystring
			strBodyText = strBodyText & " - " & strItem & " : " & request.querystring(strItem) & vbcrlf
		next
		
		'Send email
		Call SendEMail(GetAppVar("emailmethod"), GetAppVar("mailserver"), strEmailTo, "", "", strEmailFrom, strEmailFrom, strEmailFrom, strEmailFrom, GetString("Config_Subjectline2") & GetString("Error_CallbackTitle"), strBodyText, "", false)
	end if		
End If
	
Call EndPage()
%>
